﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager;

namespace XamDockManagerPreview
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Page1 : Page
    {
        public Page1()
        {
            InitializeComponent();

            this.AddHandler(ContentPane.OptionsMenuOpeningEvent, new EventHandler<Infragistics.Windows.DockManager.Events.PaneOptionsMenuOpeningEventArgs>(contentPane_OptionsMenuOpening));
            Infragistics.Windows.DockManager.Resources.Customizer.SetCustomizedString("PaneNavigatorActiveFilesLabel", "Active Windows");
            this.mainDockSite.PinBehavior = PaneActionBehavior.AllPanes;
            this.AddHandler(XamDockManager.PaneDragEndedEvent, new EventHandler<Infragistics.Windows.DockManager.Events.PaneDragEndedEventArgs>(mainDockSite_PaneDragEnded));
            //this.mainDockSite.ExecutedCommand += new EventHandler<Infragistics.Windows.Controls.Events.ExecutedCommandEventArgs>(mainDockSite_ExecutedCommand);
            this.AddHandler(XamDockManager.ExecutingCommandEvent, new EventHandler<Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs>(mainDockSite_ExecutingCommand));
        }

        void mainDockSite_ExecutingCommand(object sender, Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs e)
        {
            if (e.Command == DockManagerCommands.ShowPaneNavigator)
            {
                // prevent this command from being processed by the xamdockmanager
                e.Cancel = true;

                // prevent the event from bubbling up any further
                e.Handled = true;

                this.RemoveHandler(XamDockManager.ExecutingCommandEvent, new EventHandler<Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs>(mainDockSite_ExecutingCommand));
                this.mainDockSite.ExecuteCommand(DockManagerCommands.ShowPaneNavigator);
                this.AddHandler(XamDockManager.ExecutingCommandEvent, new EventHandler<Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs>(mainDockSite_ExecutingCommand));
            } 
        }


        void mainDockSite_PaneDragEnded(object sender, Infragistics.Windows.DockManager.Events.PaneDragEndedEventArgs e)
        {
            ContentPane cp = e.Panes[0] as ContentPane;
            if (((cp.PaneLocation == PaneLocation.DockedLeft) ||(cp.PaneLocation == PaneLocation.DockedBottom) ||(cp.PaneLocation == PaneLocation.DockedTop) ||(cp.PaneLocation == PaneLocation.DockedRight))&& cp.IsPinned == true)
            {
                cp.IsPinned = false;
            }

            this.mainDockSite.PaneNavigatorButtonDisplayMode = PaneNavigatorButtonDisplayMode.Never;
        }

        void contentPane_OptionsMenuOpening(object sender, Infragistics.Windows.DockManager.Events.PaneOptionsMenuOpeningEventArgs e)
        {
            ItemCollection ic = e.Items;
            for (int i = ic.Count - 1; i >= 0; i--)
            {
                MenuItem mItem = ic[i] as MenuItem;
                if (mItem != null && mItem.Header.ToString() == "Hide")
                {
                    ic.RemoveAt(i);
                }
            }
        }

        
     
    }
}
